diff --git a/src/main/java/net/minecraft/client/option/GameSettings.java b/src/main/java/net/minecraft/client/option/GameSettings.java
index 26755d91e..7ad459b83 100644
--- a/src/main/java/net/minecraft/client/option/GameSettings.java
+++ b/src/main/java/net/minecraft/client/option/GameSettings.java
@@ -37,136 +37,136 @@ public class GameSettings {
 	public final Minecraft mc;
 	private final File optionsFile;
 
-	public IntegerOption windowWidth = new IntegerOption(this, "windowWidth", 854);
-	public IntegerOption windowHeight = new IntegerOption(this, "windowHeight", 480);
+	public OptionInteger windowWidth = new OptionInteger(this, "windowWidth", 854);
+	public OptionInteger windowHeight = new OptionInteger(this, "windowHeight", 480);
 	
-	public VolumeOption masterVolume = new VolumeOption(this, "sound.master", 1.0f, SoundCategory.GUI_SOUNDS);
-	public VolumeOption musicVolume = new VolumeOption(this, "sound.music", 1.0f, SoundCategory.MUSIC);
-	public VolumeOption worldSoundsVolume = new VolumeOption(this, "sound.world", 1.0f, SoundCategory.WORLD_SOUNDS);
-	public VolumeOption entitySoundsVolume = new VolumeOption(this, "sound.entity", 1.0f, SoundCategory.ENTITY_SOUNDS);
-	public VolumeOption caveSoundsVolume = new VolumeOption(this, "sound.cave", 1.0f, SoundCategory.CAVE_SOUNDS);
-	public VolumeOption guiSoundsVolume = new VolumeOption(this, "sound.gui", 1.0f, SoundCategory.GUI_SOUNDS);
-	public VolumeOption weatherSoundsVolume = new VolumeOption(this, "sound.weather", 1.0f, SoundCategory.WEATHER_SOUNDS);
+	public OptionVolume masterVolume = new OptionVolume(this, "sound.master", 1.0f, SoundCategory.GUI_SOUNDS);
+	public OptionVolume musicVolume = new OptionVolume(this, "sound.music", 1.0f, SoundCategory.MUSIC);
+	public OptionVolume worldSoundsVolume = new OptionVolume(this, "sound.world", 1.0f, SoundCategory.WORLD_SOUNDS);
+	public OptionVolume entitySoundsVolume = new OptionVolume(this, "sound.entity", 1.0f, SoundCategory.ENTITY_SOUNDS);
+	public OptionVolume caveSoundsVolume = new OptionVolume(this, "sound.cave", 1.0f, SoundCategory.CAVE_SOUNDS);
+	public OptionVolume guiSoundsVolume = new OptionVolume(this, "sound.gui", 1.0f, SoundCategory.GUI_SOUNDS);
+	public OptionVolume weatherSoundsVolume = new OptionVolume(this, "sound.weather", 1.0f, SoundCategory.WEATHER_SOUNDS);
 	
-	public FloatOption FoV = new FloatOption(this, "fov", 0.40140846f);
-	public FloatOption mouseSensitivity = new FloatOption(this, "mouseSensitivity", 0.5f);
-	public FloatOption screenPadding = new FloatOption(this, "screenPadding", 0.0f);
-	public FloatOption gamma = new FloatOption(this, "gamma", 0.5f);
-	public FloatOption brightness = new FloatOption(this, "brightness", 0.5f);
+	public OptionFloat FoV = new OptionFloat(this, "fov", 0.40140846f);
+	public OptionFloat mouseSensitivity = new OptionFloat(this, "mouseSensitivity", 0.5f);
+	public OptionFloat screenPadding = new OptionFloat(this, "screenPadding", 0.0f);
+	public OptionFloat gamma = new OptionFloat(this, "gamma", 0.5f);
+	public OptionFloat brightness = new OptionFloat(this, "brightness", 0.5f);
 
-	public FloatOption fxaa = new FloatOption(this, "fxaa", 0.0f);
-	public FloatOption controllerSensitivity = new FloatOption(this, "controllerSensitivity", 0.5f);
-	public FloatOption controllerMenuSensitivity = new FloatOption(this, "controllerMenuSensitivity", 0.5f);
-	public FloatOption controllerDeadzoneLeft = new FloatOption(this, "controllerDeadzoneL", 0.25f);
-	public FloatOption controllerDeadzoneRight = new FloatOption(this, "controllerDeadzoneR", 0.25f);
-	public FloatOption blockOutlineWidth = new FloatOption(this, "blockOutlineWidth", 0.25f);
+	public OptionFloat fxaa = new OptionFloat(this, "fxaa", 0.0f);
+	public OptionFloat controllerSensitivity = new OptionFloat(this, "controllerSensitivity", 0.5f);
+	public OptionFloat controllerMenuSensitivity = new OptionFloat(this, "controllerMenuSensitivity", 0.5f);
+	public OptionFloat controllerDeadzoneLeft = new OptionFloat(this, "controllerDeadzoneL", 0.25f);
+	public OptionFloat controllerDeadzoneRight = new OptionFloat(this, "controllerDeadzoneR", 0.25f);
+	public OptionFloat blockOutlineWidth = new OptionFloat(this, "blockOutlineWidth", 0.25f);
 	
-	public FloatOption flightSpeed = new FloatOption(this, "flightSpeed", 0.5f);
-	public FloatOption flightSmoothness = new FloatOption(this, "flightSmoothness", 0.5f);
+	public OptionFloat flightSpeed = new OptionFloat(this, "flightSpeed", 0.5f);
+	public OptionFloat flightSmoothness = new OptionFloat(this, "flightSmoothness", 0.5f);
 
-	public BooleanOption invertMouse = new BooleanOption(this, "invertYMouse", false);
-	public BooleanOption rawMouseInput = new BooleanOption(this, "rawMouseInput", false);
-	public BooleanOption viewBobbing = new BooleanOption(this, "bobView", true);
-	public BooleanOption advancedOpenGL = new BooleanOption(this, "advancedOpengl", false);
-	public RangeOption fancyGraphics = new RangeOption(this, "fancyGraphics", 1, 2);
-	public BooleanOption treeShadows = new BooleanOption(this, "treeShadows", true);
-	public BooleanOption ambientOcclusion = new BooleanOption(this, "ambientOcclusion", true);
-	public BooleanOption items3D = new BooleanOption(this, "3Ditems", false);
-	public BooleanOption smoothCamera = new BooleanOption(this, "smoothCamera", false);
-	public BooleanOption lockCamera = new BooleanOption(this, "lockCamera", false);
-	public BooleanOption biomeWater = new BooleanOption(this, "biomeWater", true);
-	public BooleanOption vignette = new BooleanOption(this, "vignette", true);
-	public BooleanOption showPlayerList = new BooleanOption(this, "showPlayerList", false);
-	public BooleanOption slimeParticles = new BooleanOption(this, "slimeParticles", true);
-	public BooleanOption disableShaders = new BooleanOption(this, "disableShaders", false);
-	public StringOption shaderOverride = new StringOption(this, "shaderOverride", "");
-	public BooleanOption autoHit = new BooleanOption(this, "autoHit", true);
-	public BooleanOption easyBridge = new BooleanOption(this, "easyBridge", true);
-	public BooleanOption foodHealthRegenOverlay = new BooleanOption(this, "foodHealthRegenOverlay", true);
-	public BooleanOption fpsInOverlay = new BooleanOption(this, "fpsInOverlay", false);
-	public BooleanOption versionInOverlay = new BooleanOption(this, "versionInOverlay", false);
-	public BooleanOption controllerSwapShoulderButtons = new BooleanOption(this, "controllerSwapShoulderButtons", false);
-	public BooleanOption controllerSwapAB = new BooleanOption(this, "controllerSwapAB", false);
-	public BooleanOption controllerSwapXY = new BooleanOption(this, "controllerSwapXY", false);
-	public BooleanOption clouds = new BooleanOption(this, "clouds", true);
-	public FloatOption cloudHeight = new FloatOption(this, "cloudHeight", 0f);
-	public BooleanOption armorDurabilityOverlay = new BooleanOption(this, "armorDurabilityOverlay", false);
-	public BooleanOption armorProtectionOverlay = new BooleanOption(this, "armorProtectionOverlay", true);
-	public BooleanOption heldItemCountOverlay = new BooleanOption(this, "heldItemCountOverlay", false);
-	public BooleanOption pauseOnLostFocus = new BooleanOption(this, "pauseOnLostFocus", true);
-	public BooleanOption showDebugScreen = new BooleanOption(this, "showDebugScreen", false);
-	public BooleanOption showFrameTimes = new BooleanOption(this, "showFrameTimes", false);
-	public BooleanOption showItemDebugInfo = new BooleanOption(this, "showItemDebugInfo", false);
-	public BooleanOption showChunkBorders = new BooleanOption(this, "showChunkBorders", false);
-	public BooleanOption showCollisionBoxes = new BooleanOption(this, "showCollisionBoxes", false);
-	public BooleanOption swapCraftingButtons = new BooleanOption(this, "swapCraftingButtons", false);
-    public BooleanOption forceUnicodeFont = new BooleanOption(this, "forceUnicodeFont", false);
-	public EnumOption<PlacementMode> placementMode = new EnumOption<>(this, "placementMode", PlacementMode.class, PlacementMode.DEFAULT).setIsSlider(false);
-	public BooleanOption discordRichPresence = new BooleanOption(this, "discordRichPresence", false);
-	public ImmersiveModeOption immersiveMode = new ImmersiveModeOption(this);
-	public ColorOption guiBackgroundColor = new ColorOption(this, "guiBackgroundColor", new Color().setARGB(0xc0101010));
-	public EnumOption<Difficulty> difficulty = new EnumOption<>(this, "difficulty", Difficulty.class, Difficulty.NORMAL); // Stub for local difficulty setting
-	public IntegerOption thirdPersonView = new IntegerOption(this, "thirdPersonView", 0);
-	public RangeOption renderDistance = new RangeOption(this, "renderDistance", 8, 2, 64);
-	public BooleanOption enableVsync = new BooleanOption(this, "enableVsync", false);
-	public EnumOption<ChatVisibility> chatVisibility = new EnumOption<>(this, "chatVisibility", ChatVisibility.class, ChatVisibility.SHOW_ALL);
-	public RangeOption customFpsLimit = new RangeOption(this,"customFpsLimit",0,241);
-	public IntegerOption guiScale = new IntegerOption(this, "guiScale", 0);
-	public IntegerOption overlayMode = new IntegerOption(this, "overlayMode", 0);
-	public IntegerOption rotationOverlayMode = new IntegerOption(this, "rotationOverlayMode", 0);
-	public RangeOption animations = new RangeOption(this, "animations", 2, 3);
-	public BooleanOption customAnimations = new BooleanOption(this, "customAnimations", true);
-	public IntegerOption playerListPosition = new IntegerOption(this, "playerListPosition", 2);
-	public BooleanOption heldItemTooltips = new BooleanOption(this, "heldItemTooltips", true);
-	public FloatOption colorCorrection = new FloatOption(this, "colorCorrection", 0.5f);
-	public BooleanOption sneakToggle = new BooleanOption(this, "sneakToggle", false);
-	public FloatOption autosaveTimer = new FloatOption(this, "autosaveTimer", 0.04166666666F);
-	public BooleanOption enableItemDragging = new BooleanOption(this, "enableItemDragging", true);
-	public RangeOption bloom = new RangeOption(this, "bloom", 0, 3);
-	public EnumOption<RenderScale> renderScale = new EnumOption<>(this, "renderScale", RenderScale.class, RenderScale.SCALE_100);
-	public BooleanOption heatHaze = new BooleanOption(this, "heatHaze", false);
-	public BooleanOption alphaMenu = new BooleanOption(this, "old", false);
-	public BooleanOption enableItemClumping = new BooleanOption(this, "enableItemClumping", false);
-	public BooleanOption alwaysShowDescriptions = new BooleanOption(this, "alwaysShowDescriptions", false);
-	public BooleanOption turnWithVehicle = new BooleanOption(this, "turnWithVehicle", true);
-	public BooleanOption disableCrashHandler = new BooleanOption(this, "disableCrashHandler", false);
-	public BooleanOption enableMultiDrawRendering = new BooleanOption(this, "enableMultiDrawRendering", true);
+	public OptionBoolean invertMouse = new OptionBoolean(this, "invertYMouse", false);
+	public OptionBoolean rawMouseInput = new OptionBoolean(this, "rawMouseInput", false);
+	public OptionBoolean viewBobbing = new OptionBoolean(this, "bobView", true);
+	public OptionBoolean advancedOpenGL = new OptionBoolean(this, "advancedOpengl", false);
+	public OptionRange fancyGraphics = new OptionRange(this, "fancyGraphics", 1, 2);
+	public OptionBoolean treeShadows = new OptionBoolean(this, "treeShadows", true);
+	public OptionBoolean ambientOcclusion = new OptionBoolean(this, "ambientOcclusion", true);
+	public OptionBoolean items3D = new OptionBoolean(this, "3Ditems", false);
+	public OptionBoolean smoothCamera = new OptionBoolean(this, "smoothCamera", false);
+	public OptionBoolean lockCamera = new OptionBoolean(this, "lockCamera", false);
+	public OptionBoolean biomeWater = new OptionBoolean(this, "biomeWater", true);
+	public OptionBoolean vignette = new OptionBoolean(this, "vignette", true);
+	public OptionBoolean showPlayerList = new OptionBoolean(this, "showPlayerList", false);
+	public OptionBoolean slimeParticles = new OptionBoolean(this, "slimeParticles", true);
+	public OptionBoolean disableShaders = new OptionBoolean(this, "disableShaders", false);
+	public OptionString shaderOverride = new OptionString(this, "shaderOverride", "");
+	public OptionBoolean autoHit = new OptionBoolean(this, "autoHit", true);
+	public OptionBoolean easyBridge = new OptionBoolean(this, "easyBridge", true);
+	public OptionBoolean foodHealthRegenOverlay = new OptionBoolean(this, "foodHealthRegenOverlay", true);
+	public OptionBoolean fpsInOverlay = new OptionBoolean(this, "fpsInOverlay", false);
+	public OptionBoolean versionInOverlay = new OptionBoolean(this, "versionInOverlay", false);
+	public OptionBoolean controllerSwapShoulderButtons = new OptionBoolean(this, "controllerSwapShoulderButtons", false);
+	public OptionBoolean controllerSwapAB = new OptionBoolean(this, "controllerSwapAB", false);
+	public OptionBoolean controllerSwapXY = new OptionBoolean(this, "controllerSwapXY", false);
+	public OptionBoolean clouds = new OptionBoolean(this, "clouds", true);
+	public OptionFloat cloudHeight = new OptionFloat(this, "cloudHeight", 0f);
+	public OptionBoolean armorDurabilityOverlay = new OptionBoolean(this, "armorDurabilityOverlay", false);
+	public OptionBoolean armorProtectionOverlay = new OptionBoolean(this, "armorProtectionOverlay", true);
+	public OptionBoolean heldItemCountOverlay = new OptionBoolean(this, "heldItemCountOverlay", false);
+	public OptionBoolean pauseOnLostFocus = new OptionBoolean(this, "pauseOnLostFocus", true);
+	public OptionBoolean showDebugScreen = new OptionBoolean(this, "showDebugScreen", false);
+	public OptionBoolean showFrameTimes = new OptionBoolean(this, "showFrameTimes", false);
+	public OptionBoolean showItemDebugInfo = new OptionBoolean(this, "showItemDebugInfo", false);
+	public OptionBoolean showChunkBorders = new OptionBoolean(this, "showChunkBorders", false);
+	public OptionBoolean showCollisionBoxes = new OptionBoolean(this, "showCollisionBoxes", false);
+	public OptionBoolean swapCraftingButtons = new OptionBoolean(this, "swapCraftingButtons", false);
+    public OptionBoolean forceUnicodeFont = new OptionBoolean(this, "forceUnicodeFont", false);
+	public OptionEnum<PlacementMode> placementMode = new OptionEnum<>(this, "placementMode", PlacementMode.class, PlacementMode.DEFAULT).setIsSlider(false);
+	public OptionBoolean discordRichPresence = new OptionBoolean(this, "discordRichPresence", false);
+	public OptionImmersiveMode immersiveMode = new OptionImmersiveMode(this);
+	public OptionColor guiBackgroundColor = new OptionColor(this, "guiBackgroundColor", new Color().setARGB(0xc0101010));
+	public OptionEnum<Difficulty> difficulty = new OptionEnum<>(this, "difficulty", Difficulty.class, Difficulty.NORMAL); // Stub for local difficulty setting
+	public OptionInteger thirdPersonView = new OptionInteger(this, "thirdPersonView", 0);
+	public OptionRange renderDistance = new OptionRange(this, "renderDistance", 8, 2, 64);
+	public OptionBoolean enableVsync = new OptionBoolean(this, "enableVsync", false);
+	public OptionEnum<ChatVisibility> chatVisibility = new OptionEnum<>(this, "chatVisibility", ChatVisibility.class, ChatVisibility.SHOW_ALL);
+	public OptionRange customFpsLimit = new OptionRange(this,"customFpsLimit",0,241);
+	public OptionInteger guiScale = new OptionInteger(this, "guiScale", 0);
+	public OptionInteger overlayMode = new OptionInteger(this, "overlayMode", 0);
+	public OptionInteger rotationOverlayMode = new OptionInteger(this, "rotationOverlayMode", 0);
+	public OptionRange animations = new OptionRange(this, "animations", 2, 3);
+	public OptionBoolean customAnimations = new OptionBoolean(this, "customAnimations", true);
+	public OptionInteger playerListPosition = new OptionInteger(this, "playerListPosition", 2);
+	public OptionBoolean heldItemTooltips = new OptionBoolean(this, "heldItemTooltips", true);
+	public OptionFloat colorCorrection = new OptionFloat(this, "colorCorrection", 0.5f);
+	public OptionBoolean sneakToggle = new OptionBoolean(this, "sneakToggle", false);
+	public OptionFloat autosaveTimer = new OptionFloat(this, "autosaveTimer", 0.04166666666F);
+	public OptionBoolean enableItemDragging = new OptionBoolean(this, "enableItemDragging", true);
+	public OptionRange bloom = new OptionRange(this, "bloom", 0, 3);
+	public OptionEnum<RenderScale> renderScale = new OptionEnum<>(this, "renderScale", RenderScale.class, RenderScale.SCALE_100);
+	public OptionBoolean heatHaze = new OptionBoolean(this, "heatHaze", false);
+	public OptionBoolean alphaMenu = new OptionBoolean(this, "old", false);
+	public OptionBoolean enableItemClumping = new OptionBoolean(this, "enableItemClumping", false);
+	public OptionBoolean alwaysShowDescriptions = new OptionBoolean(this, "alwaysShowDescriptions", false);
+	public OptionBoolean turnWithVehicle = new OptionBoolean(this, "turnWithVehicle", true);
+	public OptionBoolean disableCrashHandler = new OptionBoolean(this, "disableCrashHandler", false);
+	public OptionBoolean enableMultiDrawRendering = new OptionBoolean(this, "enableMultiDrawRendering", true);
 
-	public BooleanOption enableDevResourceLoading = new BooleanOption(this, "enableDevResourceLoading", false);
-	public BooleanOption downloadSoundfiles = new BooleanOption(this, "downloadSoundfiles", true);
-	public BooleanOption allowSoundOverrides = new BooleanOption(this, "allowSoundOverrides", false);
-	public BooleanOption loadAllSounds = new BooleanOption(this, "loadAllSounds", false);
+	public OptionBoolean enableDevResourceLoading = new OptionBoolean(this, "enableDevResourceLoading", false);
+	public OptionBoolean downloadSoundfiles = new OptionBoolean(this, "downloadSoundfiles", true);
+	public OptionBoolean allowSoundOverrides = new OptionBoolean(this, "allowSoundOverrides", false);
+	public OptionBoolean loadAllSounds = new OptionBoolean(this, "loadAllSounds", false);
 	
-	public BooleanOption overlayShowCoords = new BooleanOption(this, "overlayShowCoords", true);
-	public BooleanOption overlayShowDirection = new BooleanOption(this, "overlayShowDirection", true);
-	public BooleanOption overlayShowTime = new BooleanOption(this, "overlayShowTime", true);
-	public BooleanOption overlayShowSeason = new BooleanOption(this, "overlayShowSeason", true);
-	public BooleanOption overlayShowWeather = new BooleanOption(this, "overlayShowWeather", true);
-	public BooleanOption overlayShowBiome = new BooleanOption(this, "overlayShowBiome", true);
+	public OptionBoolean overlayShowCoords = new OptionBoolean(this, "overlayShowCoords", true);
+	public OptionBoolean overlayShowDirection = new OptionBoolean(this, "overlayShowDirection", true);
+	public OptionBoolean overlayShowTime = new OptionBoolean(this, "overlayShowTime", true);
+	public OptionBoolean overlayShowSeason = new OptionBoolean(this, "overlayShowSeason", true);
+	public OptionBoolean overlayShowWeather = new OptionBoolean(this, "overlayShowWeather", true);
+	public OptionBoolean overlayShowBiome = new OptionBoolean(this, "overlayShowBiome", true);
 	
-	public BooleanOption[] overlayElements = new BooleanOption[] { overlayShowCoords, overlayShowDirection, overlayShowTime, overlayShowSeason, overlayShowWeather, overlayShowBiome };
+	public OptionBoolean[] overlayElements = new OptionBoolean[] { overlayShowCoords, overlayShowDirection, overlayShowTime, overlayShowSeason, overlayShowWeather, overlayShowBiome };
 	
-	public StringOption lastServer = new StringOption(this, "lastServer", "");
-	public StringOption skin = new StringOption(this, "skin", "Default");
-	public StringOption selectedController = new StringOption(this, "selectedController", "");
-    public StringOption language = new StringOption(this, "language", "en_US");
+	public OptionString lastServer = new OptionString(this, "lastServer", "");
+	public OptionString skin = new OptionString(this, "skin", "Default");
+	public OptionString selectedController = new OptionString(this, "selectedController", "");
+    public OptionString language = new OptionString(this, "language", "en_US");
 	
-	public RangeOption mipmapLevels = new RangeOption(this, "mipmapLevels", 0, 5);
-	public EnumOption<MipmapType> mipmapType = new EnumOption<>(this, "mipmapType", MipmapType.class, MipmapType.SMOOTH);
+	public OptionRange mipmapLevels = new OptionRange(this, "mipmapLevels", 0, 5);
+	public OptionEnum<MipmapType> mipmapType = new OptionEnum<>(this, "mipmapType", MipmapType.class, MipmapType.SMOOTH);
 
-	public BooleanOption fullscreen = new BooleanOption(this, "fullscreen", false);
-	public BooleanOption borderlessFullscreen = new BooleanOption(this, "borderlessFullscreen", true);
-	public BooleanOption startInFullscreen = new BooleanOption(this, "startInFullscreen", true);
-	public EnumOption<TooltipStyle> tooltipStyle = new EnumOption<>(this, "tooltipStyle", TooltipStyle.class);
-	public EnumOption<LightmapStyle> lightmapStyle = new EnumOption<>(this, "lightmapStyle", LightmapStyle.class, LightmapStyle.GRAY);
-	public BooleanOption customLightmap = new BooleanOption(this, "customLightmap", true);
-	public BooleanOption fog = new BooleanOption(this, "fog", true);
-	public BooleanOption hideUndiscoveredItems = new BooleanOption(this, "hideUndiscoveredItems", true);
-	public BooleanOption muteOnLostFocus = new BooleanOption(this, "muteOnLostFocus", false);
-	public BooleanOption aurora = new BooleanOption(this, "aurora", true);
-	public BooleanOption mobVariants = new BooleanOption(this, "mobVariants", true);
-	public EnumOption<Colorblindness> colorblindnessFix = new EnumOption<>(this, "colorblindnessFix", Colorblindness.class, Colorblindness.NONE);
-	public BooleanOption subtitles = new BooleanOption(this, "subtitles", false);
+	public OptionBoolean fullscreen = new OptionBoolean(this, "fullscreen", false);
+	public OptionBoolean borderlessFullscreen = new OptionBoolean(this, "borderlessFullscreen", true);
+	public OptionBoolean startInFullscreen = new OptionBoolean(this, "startInFullscreen", true);
+	public OptionEnum<TooltipStyle> tooltipStyle = new OptionEnum<>(this, "tooltipStyle", TooltipStyle.class);
+	public OptionEnum<LightmapStyle> lightmapStyle = new OptionEnum<>(this, "lightmapStyle", LightmapStyle.class, LightmapStyle.GRAY);
+	public OptionBoolean customLightmap = new OptionBoolean(this, "customLightmap", true);
+	public OptionBoolean fog = new OptionBoolean(this, "fog", true);
+	public OptionBoolean hideUndiscoveredItems = new OptionBoolean(this, "hideUndiscoveredItems", true);
+	public OptionBoolean muteOnLostFocus = new OptionBoolean(this, "muteOnLostFocus", false);
+	public OptionBoolean aurora = new OptionBoolean(this, "aurora", true);
+	public OptionBoolean mobVariants = new OptionBoolean(this, "mobVariants", true);
+	public OptionEnum<Colorblindness> colorblindnessFix = new OptionEnum<>(this, "colorblindnessFix", Colorblindness.class, Colorblindness.NONE);
+	public OptionBoolean subtitles = new OptionBoolean(this, "subtitles", false);
 
 	public KeyBinding keyAttack = new KeyBinding("key.attack").setDefault(InputDevice.mouse, 0);
 	public KeyBinding keyInteract = new KeyBinding("key.interact").setDefault(InputDevice.mouse, 1);
@@ -277,9 +277,9 @@ public class GameSettings {
 	public String getDisplayString(Option<?> option) {
 		if (option == null) return "";
 		I18n trans = I18n.getInstance();
-		if (option instanceof FloatOption) {
-			FloatOption floatOption = (FloatOption) option;
-			float value = floatOption.value;
+		if (option instanceof OptionFloat) {
+			OptionFloat optionFloat = (OptionFloat) option;
+			float value = optionFloat.value;
 			if (option == brightness) {
 				int percent = (int)(value * 200.0f);
 				if (percent == 0) {
@@ -385,7 +385,7 @@ public class GameSettings {
 				return trans.translateKey("options.bloom.high");
 			}
 		}
-		if (option instanceof BooleanOption) {
+		if (option instanceof OptionBoolean) {
 			Boolean flag = (Boolean) option.value;
 			if (flag) {
 				return trans.translateKey("options.on");
@@ -393,20 +393,20 @@ public class GameSettings {
 				return trans.translateKey("options.off");
 			}
 		}
-		if(option instanceof EnumOption<?>) {
-			EnumOption<?> enumOption = (EnumOption<?>) option;
+		if(option instanceof OptionEnum<?>) {
+			OptionEnum<?> optionEnum = (OptionEnum<?>) option;
 			
 			String key;
 			
-			if(enumOption.value instanceof ITranslatable) {
-				ITranslatable translatable = (ITranslatable) enumOption.value;
+			if(optionEnum.value instanceof ITranslatable) {
+				ITranslatable translatable = (ITranslatable) optionEnum.value;
 				
 				key = translatable.getTranslationKey();
 			}else {
-				key = enumOption.value.toString().toLowerCase();
+				key = optionEnum.value.toString().toLowerCase();
 			}
 			
-			return trans.translateKey("options." + enumOption.name+"." + key);
+			return trans.translateKey("options." + optionEnum.name+"." + key);
 		}
 		return option.value.toString();
 	}
diff --git a/src/main/java/net/minecraft/client/option/BooleanOption.java b/src/main/java/net/minecraft/client/option/OptionBoolean.java
similarity index 78%
rename from src/main/java/net/minecraft/client/option/BooleanOption.java
rename to src/main/java/net/minecraft/client/option/OptionBoolean.java
index 096f4ab4c..cf9d3ec47 100644
--- a/src/main/java/net/minecraft/client/option/BooleanOption.java
+++ b/src/main/java/net/minecraft/client/option/OptionBoolean.java
@@ -2,11 +2,11 @@ package net.minecraft.client.option;
 
 import net.minecraft.core.util.helper.Toggleable;
 
-public class BooleanOption extends ToggleableOption<Boolean> implements Toggleable{
+public class OptionBoolean extends OptionToggleable<Boolean> implements Toggleable{
 	
 	public static final Boolean[] values = new Boolean[] {false, true};
 	
-	public BooleanOption(GameSettings gameSettings, String name, boolean value) {
+	public OptionBoolean(GameSettings gameSettings, String name, boolean value) {
 		super(gameSettings, name, value, values);
 	}
 	
diff --git a/src/main/java/net/minecraft/client/option/ColorOption.java b/src/main/java/net/minecraft/client/option/OptionColor.java
similarity index 83%
rename from src/main/java/net/minecraft/client/option/ColorOption.java
rename to src/main/java/net/minecraft/client/option/OptionColor.java
index 82c686dff..7ed3abb37 100644
--- a/src/main/java/net/minecraft/client/option/ColorOption.java
+++ b/src/main/java/net/minecraft/client/option/OptionColor.java
@@ -4,9 +4,9 @@ import com.mojang.logging.LogUtils;
 import net.minecraft.core.util.helper.Color;
 import org.slf4j.Logger;
 
-public class ColorOption extends Option<Color>{
+public class OptionColor extends Option<Color>{
 	private static final Logger LOGGER = LogUtils.getLogger();
-	public ColorOption(GameSettings gameSettings, String name, Color defaultValue) {
+	public OptionColor(GameSettings gameSettings, String name, Color defaultValue) {
 		super(gameSettings, name, defaultValue);
 	}
 
diff --git a/src/main/java/net/minecraft/client/option/EnumOption.java b/src/main/java/net/minecraft/client/option/OptionEnum.java
similarity index 67%
rename from src/main/java/net/minecraft/client/option/EnumOption.java
rename to src/main/java/net/minecraft/client/option/OptionEnum.java
index e7a686b6e..765155ba0 100644
--- a/src/main/java/net/minecraft/client/option/EnumOption.java
+++ b/src/main/java/net/minecraft/client/option/OptionEnum.java
@@ -2,15 +2,15 @@ package net.minecraft.client.option;
 
 import net.minecraft.core.util.helper.Toggleable;
 
-public class EnumOption<E extends Enum<?>> extends ToggleableOption<E> implements Toggleable{
+public class OptionEnum<E extends Enum<?>> extends OptionToggleable<E> implements Toggleable{
 	
 	private boolean isSlider;
 	
-	public EnumOption(GameSettings gameSettings, String name, Class<E> clazz) {
+	public OptionEnum(GameSettings gameSettings, String name, Class<E> clazz) {
 		this(gameSettings, name, clazz, clazz.getEnumConstants()[0]);
 	}
 
-	public EnumOption(GameSettings gameSettings, String name, Class<E> clazz, E defaultValue) {
+	public OptionEnum(GameSettings gameSettings, String name, Class<E> clazz, E defaultValue) {
 		super(gameSettings, name, defaultValue, clazz.getEnumConstants());
 	}
 
@@ -23,7 +23,7 @@ public class EnumOption<E extends Enum<?>> extends ToggleableOption<E> implement
 		}
 	}
 
-	public EnumOption<E> setIsSlider(boolean isSlider) {
+	public OptionEnum<E> setIsSlider(boolean isSlider) {
 		this.isSlider = isSlider;
 		return this;
 	}
diff --git a/src/main/java/net/minecraft/client/option/FloatOption.java b/src/main/java/net/minecraft/client/option/OptionFloat.java
similarity index 77%
rename from src/main/java/net/minecraft/client/option/FloatOption.java
rename to src/main/java/net/minecraft/client/option/OptionFloat.java
index 3eca33be7..588f87589 100644
--- a/src/main/java/net/minecraft/client/option/FloatOption.java
+++ b/src/main/java/net/minecraft/client/option/OptionFloat.java
@@ -1,8 +1,8 @@
 package net.minecraft.client.option;
 
-public class FloatOption extends Option<Float>{
+public class OptionFloat extends Option<Float>{
 
-	public FloatOption(GameSettings gameSettings, String name, float value) {
+	public OptionFloat(GameSettings gameSettings, String name, float value) {
 		super(gameSettings, name, value);
 	}
 	
diff --git a/src/main/java/net/minecraft/client/option/ImmersiveModeOption.java b/src/main/java/net/minecraft/client/option/OptionImmersiveMode.java
similarity index 83%
rename from src/main/java/net/minecraft/client/option/ImmersiveModeOption.java
rename to src/main/java/net/minecraft/client/option/OptionImmersiveMode.java
index 36339e3c5..23034b3a9 100644
--- a/src/main/java/net/minecraft/client/option/ImmersiveModeOption.java
+++ b/src/main/java/net/minecraft/client/option/OptionImmersiveMode.java
@@ -1,8 +1,8 @@
 package net.minecraft.client.option;
 
-public class ImmersiveModeOption extends IntegerOption{
+public class OptionImmersiveMode extends OptionInteger {
 
-	public ImmersiveModeOption(GameSettings gameSettings) {
+	public OptionImmersiveMode(GameSettings gameSettings) {
 		super(gameSettings, "immersiveMode", 0);
 	}
 	
diff --git a/src/main/java/net/minecraft/client/option/IntegerOption.java b/src/main/java/net/minecraft/client/option/OptionInteger.java
similarity index 63%
rename from src/main/java/net/minecraft/client/option/IntegerOption.java
rename to src/main/java/net/minecraft/client/option/OptionInteger.java
index b07571134..20c8d2df2 100644
--- a/src/main/java/net/minecraft/client/option/IntegerOption.java
+++ b/src/main/java/net/minecraft/client/option/OptionInteger.java
@@ -1,8 +1,8 @@
 package net.minecraft.client.option;
 
-public class IntegerOption extends Option<Integer>{
+public class OptionInteger extends Option<Integer>{
 
-	public IntegerOption(GameSettings gameSettings, String name, int defaultValue) {
+	public OptionInteger(GameSettings gameSettings, String name, int defaultValue) {
 		super(gameSettings, name, defaultValue);
 	}
 
